# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2018-10-05.      #
#                                                           #
# Ruby Bindings Version 2.1.19                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Measures acceleration in three axis
  class BrickletAccelerometer < Device
    DEVICE_IDENTIFIER = 250 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Accelerometer Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletAccelerometer#set_acceleration_callback_period. The parameters are the
    # X, Y and Z acceleration.
    # 
    # The CALLBACK_ACCELERATION callback is only triggered if the acceleration has
    # changed since the last triggering.
    CALLBACK_ACCELERATION = 14

    # This callback is triggered when the threshold as set by
    # BrickletAccelerometer#set_acceleration_callback_threshold is reached.
    # The parameters are the X, Y and Z acceleration.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletAccelerometer#set_debounce_period.
    CALLBACK_ACCELERATION_REACHED = 15

    FUNCTION_GET_ACCELERATION = 1 # :nodoc:
    FUNCTION_SET_ACCELERATION_CALLBACK_PERIOD = 2 # :nodoc:
    FUNCTION_GET_ACCELERATION_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_SET_ACCELERATION_CALLBACK_THRESHOLD = 4 # :nodoc:
    FUNCTION_GET_ACCELERATION_CALLBACK_THRESHOLD = 5 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 6 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 7 # :nodoc:
    FUNCTION_GET_TEMPERATURE = 8 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 9 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 10 # :nodoc:
    FUNCTION_LED_ON = 11 # :nodoc:
    FUNCTION_LED_OFF = 12 # :nodoc:
    FUNCTION_IS_LED_ON = 13 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    DATA_RATE_OFF = 0 # :nodoc:
    DATA_RATE_3HZ = 1 # :nodoc:
    DATA_RATE_6HZ = 2 # :nodoc:
    DATA_RATE_12HZ = 3 # :nodoc:
    DATA_RATE_25HZ = 4 # :nodoc:
    DATA_RATE_50HZ = 5 # :nodoc:
    DATA_RATE_100HZ = 6 # :nodoc:
    DATA_RATE_400HZ = 7 # :nodoc:
    DATA_RATE_800HZ = 8 # :nodoc:
    DATA_RATE_1600HZ = 9 # :nodoc:
    FULL_SCALE_2G = 0 # :nodoc:
    FULL_SCALE_4G = 1 # :nodoc:
    FULL_SCALE_6G = 2 # :nodoc:
    FULL_SCALE_8G = 3 # :nodoc:
    FULL_SCALE_16G = 4 # :nodoc:
    FILTER_BANDWIDTH_800HZ = 0 # :nodoc:
    FILTER_BANDWIDTH_400HZ = 1 # :nodoc:
    FILTER_BANDWIDTH_200HZ = 2 # :nodoc:
    FILTER_BANDWIDTH_50HZ = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_GET_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ACCELERATION_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ACCELERATION_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ACCELERATION_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ACCELERATION_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_LED_ON] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_LED_OFF] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_LED_ON] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_ACCELERATION] = 's s s'
      @callback_formats[CALLBACK_ACCELERATION_REACHED] = 's s s'

    end

    # Returns the acceleration in x, y and z direction. The values
    # are given in g/1000 (1g = 9.80665m/s²), not to be confused with grams.
    # 
    # If you want to get the acceleration periodically, it is recommended
    # to use the CALLBACK_ACCELERATION callback and set the period with
    # BrickletAccelerometer#set_acceleration_callback_period.
    def get_acceleration
      send_request FUNCTION_GET_ACCELERATION, [], '', 6, 's s s'
    end

    # Sets the period in ms with which the CALLBACK_ACCELERATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_ACCELERATION callback is only triggered if the acceleration has
    # changed since the last triggering.
    # 
    # The default value is 0.
    def set_acceleration_callback_period(period)
      send_request FUNCTION_SET_ACCELERATION_CALLBACK_PERIOD, [period], 'L', 0, ''
    end

    # Returns the period as set by BrickletAccelerometer#set_acceleration_callback_period.
    def get_acceleration_callback_period
      send_request FUNCTION_GET_ACCELERATION_CALLBACK_PERIOD, [], '', 4, 'L'
    end

    # Sets the thresholds for the CALLBACK_ACCELERATION_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the acceleration is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the acceleration is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the acceleration is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the acceleration is greater than the min value (max is ignored)"
    # 
    # The default value is ('x', 0, 0, 0, 0, 0, 0).
    def set_acceleration_callback_threshold(option, min_x, max_x, min_y, max_y, min_z, max_z)
      send_request FUNCTION_SET_ACCELERATION_CALLBACK_THRESHOLD, [option, min_x, max_x, min_y, max_y, min_z, max_z], 'k s s s s s s', 0, ''
    end

    # Returns the threshold as set by BrickletAccelerometer#set_acceleration_callback_threshold.
    def get_acceleration_callback_threshold
      send_request FUNCTION_GET_ACCELERATION_CALLBACK_THRESHOLD, [], '', 13, 'k s s s s s s'
    end

    # Sets the period in ms with which the threshold callback
    # 
    # * CALLBACK_ACCELERATION_REACHED
    # 
    # is triggered, if the threshold
    # 
    # * BrickletAccelerometer#set_acceleration_callback_threshold
    # 
    # keeps being reached.
    # 
    # The default value is 100.
    def set_debounce_period(debounce)
      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 0, ''
    end

    # Returns the debounce period as set by BrickletAccelerometer#set_debounce_period.
    def get_debounce_period
      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 4, 'L'
    end

    # Returns the temperature of the accelerometer in °C.
    def get_temperature
      send_request FUNCTION_GET_TEMPERATURE, [], '', 2, 's'
    end

    # Configures the data rate, full scale range and filter bandwidth.
    # Possible values are:
    # 
    # * Data rate of 0Hz to 1600Hz.
    # * Full scale range of -2G to +2G up to -16G to +16G.
    # * Filter bandwidth between 50Hz and 800Hz.
    # 
    # Decreasing data rate or full scale range will also decrease the noise on
    # the data.
    # 
    # The default values are 100Hz data rate, -4G to +4G range and 200Hz
    # filter bandwidth.
    def set_configuration(data_rate, full_scale, filter_bandwidth)
      send_request FUNCTION_SET_CONFIGURATION, [data_rate, full_scale, filter_bandwidth], 'C C C', 0, ''
    end

    # Returns the configuration as set by BrickletAccelerometer#set_configuration.
    def get_configuration
      send_request FUNCTION_GET_CONFIGURATION, [], '', 3, 'C C C'
    end

    # Enables the LED on the Bricklet.
    def led_on
      send_request FUNCTION_LED_ON, [], '', 0, ''
    end

    # Disables the LED on the Bricklet.
    def led_off
      send_request FUNCTION_LED_OFF, [], '', 0, ''
    end

    # Returns *true* if the LED is enabled, *false* otherwise.
    def is_led_on
      send_request FUNCTION_IS_LED_ON, [], '', 1, '?'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
