# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2018-10-05.      #
#                                                           #
# Ruby Bindings Version 2.1.19                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Controls one RGB LED
  class BrickletRGBLED < Device
    DEVICE_IDENTIFIER = 271 # :nodoc:
    DEVICE_DISPLAY_NAME = 'RGB LED Bricklet' # :nodoc:

    FUNCTION_SET_RGB_VALUE = 1 # :nodoc:
    FUNCTION_GET_RGB_VALUE = 2 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:


    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_RGB_VALUE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RGB_VALUE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE


    end

    # Sets the *rgb* value for the LED. The value can be between 0 and 255.
    def set_rgb_value(r, g, b)
      send_request FUNCTION_SET_RGB_VALUE, [r, g, b], 'C C C', 0, ''
    end

    # Returns the *rgb* value of the LED as set by BrickletRGBLED#set_rgb_value.
    def get_rgb_value
      send_request FUNCTION_GET_RGB_VALUE, [], '', 3, 'C C C'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S'
    end

  end
end
